--[F/A] derelky
baleIdManagerGui = {}
baleIdManagerGui.BUILD_ID = 3

local baleIdManagerGui_mt = Class(baleIdManagerGui, YesNoDialog)

baleIdManagerGui.CONTROLS = {
    GENERAL_CONTAINER = "generalContainer",
    HELP_BOX_TEXT = "generalHelpBoxText",
    COST_BOX_TEXT = "generalCostBoxText",
    HELP_BOX = "generalHelpBox",
    SET_FARMID_CHANGE_ID = "setFarmIDChange",
    FARMID_1_COUNTER = "Farm1counter",
    FARMID_2_COUNTER = "Farm2counter",
    FARMID_3_COUNTER = "Farm3counter",
    FARMID_4_COUNTER = "Farm4counter",
    FARMID_5_COUNTER = "Farm5counter",
    FARMID_6_COUNTER = "Farm6counter",
    FARMID_7_COUNTER = "Farm7counter",
    FARMID_8_COUNTER = "Farm8counter",
    FARMID_1_NAME = "Farm1name",
    FARMID_2_NAME = "Farm2name",
    FARMID_3_NAME = "Farm3name",
    FARMID_4_NAME = "Farm4name",
    FARMID_5_NAME = "Farm5name",
    FARMID_6_NAME = "Farm6name",
    FARMID_7_NAME = "Farm7name",
    FARMID_8_NAME = "Farm8name",
    VEHICLE_NAME = "vehiclename",
    VEHICLE_IMAGE = "vehicleImage",
    CONTRACTSTATE = "setContractorstate",
    FARMCHOOSE = "Farmchoose",
    BALEIDUSECONTRACT = "baleIdUseContract",
    FARMBALECOUNTER = "FarmBaleCounter",
    BALESTEXT1 = "balestext1",
    BALESTEXT2 = "balestext2",
    BALESTEXT3 = "balestext3",
    BALESTEXT4 = "balestext4",
    BALESTEXT5 = "balestext5",
    BALESTEXT6 = "balestext6",
    BALESTEXT7 = "balestext7",
    BALESTEXT8 = "balestext8",
    DIALOGTITLEELEMENT = "dialogTitleElement",
    BALEFILLTYPE = "balefilltype",
    CLEARBALETEXT = "clearbaletext",
    BALEFILLLEVEL = "balefilllevel",
    RESETBALEFILL = "Resetbalefill",

}


function baleIdManagerGui:new(target, custom_mt)
    local self = YesNoDialog:new(target, custom_mt or baleIdManagerGui_mt)

    self:registerControls(baleIdManagerGui.CONTROLS)
    self.isServer = g_server ~= nil
	
    return self
end

function baleIdManagerGui:loadFarmID(guifarmID, guifarmIDs, guicontranctactive, ismp)
    self.guifarmID = guifarmID
    self.guifarmIDs = guifarmIDs
	local findex = 1
	local i=1
	for _,n in pairs (self.guifarmIDs) do
		if self.guifarmID  == n then
			findex = i
		end
		i=i+1
	end
	if ismp then
		self.guicontranctactive = guicontranctactive
		self.FARMID =self.guifarmIDs
		self.setContractorstate:setIsChecked(self.guicontranctactive)
		self.setFarmIDChange:setTexts(self.FARMID)
		self.setFarmIDChange:setState(findex, true)	
		self:changevisible(self.guicontranctactive)
	else
		self.setContractorstate:setVisible(false)
		self:changevisible(false)
		self.Farm2name:setVisible(false)
		self.Farm3name:setVisible(false)
		self.Farm4name:setVisible(false)
		self.Farm5name:setVisible(false)
		self.Farm6name:setVisible(false)
		self.Farm7name:setVisible(false)
		self.Farm8name:setVisible(false)
	end
end

function baleIdManagerGui:FarmCallback(callback,bcallback, target)
    self.target = target
    self.callback = callback
    self.bcallback = bcallback
	self:changefilltype(self.target)
	if self.target ~= nil then
         local vehicle = self.target
         local storeItem = g_storeManager:getItemByXMLFilename(vehicle.configFileName:lower())	
         self.vehiclename:setText(storeItem.name)
         self.vehicleImage:setImageFilename(storeItem.imageFilename)
		
	end
end

function baleIdManagerGui:loadbalecounter(balecounter)
	self.balecounter=balecounter
	self.Farm1counter:setText(self.balecounter[1])
	self.Farm2counter:setText(self.balecounter[2])
	self.Farm3counter:setText(self.balecounter[3])
	self.Farm4counter:setText(self.balecounter[4])
	self.Farm5counter:setText(self.balecounter[5])
	self.Farm6counter:setText(self.balecounter[6])
	self.Farm7counter:setText(self.balecounter[7])
	self.Farm8counter:setText(self.balecounter[8])
end                       

function baleIdManagerGui:update(dt)
    baleIdManagerGui:superClass().update(self, dt)
end


function baleIdManagerGui:onClickOk()
    if self.callback == nil then
        return true
    end

    if self.target ~= nil then
        self.callback(self.target, self.guifarmID,self.guicontranctactive )
    else
        print("  Error: [baleIdManagerGui]  Target is missing.")
    end

    self:close()
end

function baleIdManagerGui:onClickBack(forceBack, usedMenuButton)
    self:close()
end

function baleIdManagerGui:onClickFarmIDChange(index)
	self.guifarmID = self.FARMID[self.setFarmIDChange:getState()]
end

function baleIdManagerGui:changetext(ModName)
	self.Farmchoose:setText(g_i18n.modEnvironments[ModName].texts.BaleIdCfarmchoose)
	self.baleIdUseContract:setText(g_i18n.modEnvironments[ModName].texts.BaleIdUseContract)
	self.FarmBaleCounter:setText(g_i18n.modEnvironments[ModName].texts.FarmBaleCounter)
	self.dialogTitleElement:setText(g_i18n.modEnvironments[ModName].texts.DialogTitleElement)
	
	self.balestext1:setText(g_i18n.modEnvironments[ModName].texts.Balestext)
	self.balestext2:setText(g_i18n.modEnvironments[ModName].texts.Balestext)
	self.balestext3:setText(g_i18n.modEnvironments[ModName].texts.Balestext)
	self.balestext4:setText(g_i18n.modEnvironments[ModName].texts.Balestext)
	self.balestext5:setText(g_i18n.modEnvironments[ModName].texts.Balestext)
	self.balestext6:setText(g_i18n.modEnvironments[ModName].texts.Balestext)
	self.balestext7:setText(g_i18n.modEnvironments[ModName].texts.Balestext)
	self.balestext8:setText(g_i18n.modEnvironments[ModName].texts.Balestext)
	
	local farmname={}
	for i=1,8,1 do
		if g_farmManager:getFarmById(i) ~=nil then
			farmname[i]=g_farmManager:getFarmById(i).name
		else
			farmname[i]=g_i18n.modEnvironments[ModName].texts.Nofarm
		end
	end
	self.Farm1name:setText("1. "..farmname[1].." :")
	self.Farm2name:setText("2. "..farmname[2].." :")
	self.Farm3name:setText("3. "..farmname[3].." :")
	self.Farm4name:setText("4. "..farmname[4].." :")
	self.Farm5name:setText("5. "..farmname[5].." :")
	self.Farm6name:setText("6. "..farmname[6].." :")
	self.Farm7name:setText("7. "..farmname[7].." :")
	self.Farm8name:setText("8. "..farmname[8].." :")
	
	self.clearbaletext:setText(g_i18n.modEnvironments[ModName].texts.Clearbale)
	self.Resetbalefill:setText(g_i18n.modEnvironments[ModName].texts.Resetbalefill)
end

function baleIdManagerGui:resetfillbaler(vehicle, noEventSend)
	
		local spec = vehicle.spec_baler
		local specDLC = vehicle.spec_extendedBaler
		local isServer = g_server ~= nil
		if not noEventSend then		
			if g_server ~= nil then
				g_server:broadcastEvent(BaleClearEvent:new(vehicle), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(BaleClearEvent:new(vehicle));
			end
		end;
        if isServer then
			vehicle:addFillUnitFillLevel(vehicle:getOwnerFarmId(), spec.fillUnitIndex, -math.huge, vehicle:getFillUnitFillType(spec.fillUnitIndex), ToolType.UNDEFINED)
			if specDLC ~=nil then
				vehicle:addFillUnitFillLevel(vehicle:getOwnerFarmId(), specDLC.fillUnitIndex, -math.huge, vehicle:getFillUnitFillType(specDLC.fillUnitIndex), ToolType.UNDEFINED)
			end			
		end		
end;


function baleIdManagerGui:changefilltype(vehicle)
	if vehicle ~= nil then
		local spec = vehicle.spec_baler
		local specDLC = vehicle.spec_extendedBaler
						
		local filltypeindex = vehicle:getFillUnitFillType(spec.fillUnitIndex)
		local filltype = g_fillTypeManager:getFillTypeByIndex(filltypeindex)
		local filltypetext = ""
        local currentFillLevel = vehicle:getFillUnitFillLevel(spec.fillUnitIndex)
		if specDLC ~=nil and currentFillLevel==0 then
			currentFillLevel = vehicle:getFillUnitFillLevel(specDLC.fillUnitIndex)
			filltypeindex = vehicle:getFillUnitFillType(specDLC.fillUnitIndex)
			filltype = g_fillTypeManager:getFillTypeByIndex(filltypeindex)
		end
		if filltype.name ~= "UNKNOWN" then
			filltypetext = filltype.title or filltype.name
		end
	
	self.balefilltype:setText(filltypetext)
	self.balefilllevel:setText(string.format("%0.f l", currentFillLevel) )
	end	

end

function baleIdManagerGui:changevisible(state)
		self.Farmchoose:setVisible(state)
		self.setFarmIDChange:setVisible(state)
end

function baleIdManagerGui:onClickContractorChange(index)
	self.guicontranctactive = self.setContractorstate:getIsChecked()
	self:changevisible(self.guicontranctactive)
end

function baleIdManagerGui:onClickclearbaler()
	if self.target ~= nil then
		self:resetfillbaler(self.target)		
		self.balefilltype:setText(" ")
		self.balefilllevel:setText(string.format("%0.f l", 0) )
	end
end

function baleIdManagerGui:onClickReset1()
	self.balecounter[1] = 0
	self:loadbalecounter(self.balecounter)
end

function baleIdManagerGui:onClickReset2()
	self.balecounter[2] = 0
	self:loadbalecounter(self.balecounter)
end

function baleIdManagerGui:onClickReset3()
	self.balecounter[3] = 0
	self:loadbalecounter(self.balecounter)
end

function baleIdManagerGui:onClickReset4()
	self.balecounter[4] = 0
	self:loadbalecounter(self.balecounter)
end

function baleIdManagerGui:onClickReset5()
	self.balecounter[5] = 0
	self:loadbalecounter(self.balecounter)
end

function baleIdManagerGui:onClickReset6()
	self.balecounter[6] = 0
	self:loadbalecounter(self.balecounter)
end

function baleIdManagerGui:onClickReset7()
	self.balecounter[7] = 0
	self:loadbalecounter(self.balecounter)
end

function baleIdManagerGui:onClickReset8()
	self.balecounter[8] = 0
	self:loadbalecounter(self.balecounter)
end


BaleClearEvent = {};
BaleClearEvent_mt = Class(BaleClearEvent, Event);

InitEventClass(BaleClearEvent, "BaleClearEvent");

function BaleClearEvent:emptyNew()
	local self = Event:new(BaleClearEvent_mt);
    
	return self;
end;

function BaleClearEvent:new(vehicle)
	local self = BaleClearEvent:emptyNew();
	
	self.vehicle = vehicle;
	
	return self;
end;

function BaleClearEvent:readStream(streamId, connection)
	self.vehicle = NetworkUtil.readNodeObject(streamId);
    
	self:run(connection);
end;

function BaleClearEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.vehicle);
end;

function BaleClearEvent:run(connection)	
    if self.vehicle ~= nil then
		if not connection:getIsServer() then
			g_server:broadcastEvent(BaleClearEvent:new(self.vehicle), nil, connection, self.vehicle);
		end;
			baleIdManagerGui:resetfillbaler(self.vehicle, true);
	end;
end;

